#include <bits/stdc++.h>

using namespace std;

int n,q;

int resenje(int x, vector<int> glasovi)
{
    auto it=lower_bound(glasovi.begin(), glasovi.end(), x);
    int i=distance(glasovi.begin(),it);
    int z=glasovi[i], razlika=n/2-i;
    if(i<n/2)
    {
        for(int k=i; glasovi[k]==z; k++)
        {
            if(n/2-k<razlika)
            {
                razlika=n/2-k;
                i=k;
            }
        }
    }
    if(glasovi[i]==x)
    {
        if(i<n/2) return n-i*2-1;
        else if(i>n/2) return i*2-n;
        else return 0;
    }
    else
    {
        if(i<(n+1)/2) return n+1-i*2;
        else if(i>(n+1)/2) return i*2-n;
        else return 1;
    }
}




int main()
{

    cin>>n>>q;
    vector<int> glasovi;
    int a,b;
    for(int i=0; i<n; i++)
    {
        cin>>a;
        glasovi.push_back(a);
    }
    for(int i=0; i<q; i++)
    {
        cin>>b;
        int ispis=resenje(b, glasovi);
        cout<<ispis<<"\n";
    }
}